ByteAddressBuffer sobuffer;

cbuffer cbPerDraw : register( b0 )
{
	float4x4 tVP : VIEWPROJECTION;	
	float stride = 56; // 12 position, 12 normal, 12 tangent, 12 binormal, 8 texcoord
};

cbuffer cbPerObj : register( b1 )
{
	float4x4 tW : WORLD;
	float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
};

struct VS_IN
{
	float4 PosO : POSITION;
	float4 TexCd : TEXCOORD0;
	float4 Normal : NORMAL;
	uint ii : SV_InstanceID;
};

struct vs2ps
{
    float4 PosWVP: SV_POSITION;
    float4 TexCd: TEXCOORD0;
	float4 Normal : NORMAL;
};

vs2ps VS(VS_IN input)
{
    vs2ps output;
	
	float4 p; // position
	float4 n; // normal
	float4 t; // tangent
	float4 b; // binormal
	
	p.x = asfloat(sobuffer.Load(input.ii * stride));
	p.y = asfloat(sobuffer.Load(input.ii * stride + 4));
	p.z = asfloat(sobuffer.Load(input.ii * stride + 8));
	p.w = 0;
	
	n.x = asfloat(sobuffer.Load(input.ii * stride + 12));
	n.y = asfloat(sobuffer.Load(input.ii * stride + 12 + 4));
	n.z = asfloat(sobuffer.Load(input.ii * stride + 12 + 8));
	n.w = 0;
	
	t.x = asfloat(sobuffer.Load(input.ii * stride + 24));
	t.y = asfloat(sobuffer.Load(input.ii * stride + 24 + 4));
	t.z = asfloat(sobuffer.Load(input.ii * stride + 24 + 8));
	t.w = 0;
	
	b.x = asfloat(sobuffer.Load(input.ii * stride + 32));
	b.y = asfloat(sobuffer.Load(input.ii * stride + 32 + 4));
	b.z = asfloat(sobuffer.Load(input.ii * stride + 32 + 8));
	b.w = 0;
	
	// shader calculate binormal, should be right not?
	//float4 bin = float4(cross(n.xyz,t.xyz),0);
	
	float4x4 rotMatrix = float4x4(n, t, b, float4(0,0,0,1));
	
	float4 pos = mul(input.PosO,rotMatrix) + p;
	
	//pos = mul(pos,rotMatrix);
	
    output.PosWVP  = mul(pos,mul(tW,tVP));
    output.TexCd = input.TexCd;
    output.Normal = input.Normal;
    return output;
}




float4 PS(vs2ps In): SV_Target
{
    float4 col = In.Normal;
    return col;
}





technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




